/*
 *  bsdfiler.h
 *
 *  revision history
 *	0.0: May  24, 1996 by Dai ISHIJIMA (pre alpha version :-)
 *	0.1: Jul. 27, 1996 (alpha version :-)
 *	0.2: Aug. 10, 1996 (beta version :-)
 *	0.3: Sep. 27, 1996 (beta version, again :-)
 */

#define YES 1
#define NO  0
#define EOS '\0'

/*
 *  ʸ
 */
#define SYN 0x16      /* Ʊ */
#define DLE 0x10      /* ĥ */
#define ETX 0x03      /* ƥȤν */
#define STX 0x02      /* ƥȤλϤޤ */
#define SOH 0x01      /* إåλϤޤ */
#define REPLYSOH 0x81 /* server -> client ξΥإåλϤޤ? */


/*
 *  Filer Υޥ
 */
#define CONNECT   0x40  /* ³׵ */
#define LOGDSK    0x11  /* ɥ饤ѹ */
#define CHDIR     0x10  /* ǥ쥯ȥѹ */
#define GETCWD    0x06  /* ȥǥ쥯ȥ׵ */
#define WILDCARD  0x12  /* ե븡ѥ磻ɥɻ */
#define GETDIRENT 0x09  /* ǥ쥯ȥꥨȥ׵ */
#define GETDFREE  0x14  /* ܥ塼٥Ȼ׵ */
#define GETFTYPE  0x08  /* ե륿׵? */
#define WRITEOPEN 0x03  /* client -> server ԡե̾ */
#define FWRITE    0x15  /* client -> server ե륳ԡ*/
#define SETSTAMP  0x18  /* client 饳ԡեΥॹ */
#define FCLOSE    0x01  /* եžγǧ? */
#define RENAME    0x0d  /* ե̾ѹ */
#define DELFILE   0x04  /* ե */
#define READOPEN  0x0b  /* server -> client ԡե̾ */
#define TRANSRDY  0x16  /* server -> client žλ? */
#define FREAD     0x0c  /* server -> client ե륳ԡ */
#define GETSTAMP  0x17  /* server 饳ԡեΥॹ׵ */
#define MKDIR     0x0a  /* ǥ쥯ȥ */
#define DISCON    0x41  /* ³ */
#define FSEEK     0x0f  /* եΥ */
#define FTELL     0x13  /* եݥ󥿤׵ */
#define AVAILDRV  0x1b  /* Ѳǽɥ饤׵ */

/*
 *  顼
 */
#define CANTMOVEDIR 0xd1 /* ꤵ줿ǥ쥯ȥ˰ưǤʤ */

/*
 *  Ƽ³
 */
#define MAXDIRENT 256    /* ǥ쥯ȥꥨȥξ */
#define MAXPACKET 3000   /* ѥåȤκĹ (ۥȤ DATBLKSIZ + ) */
#define MAXLINE 80       /* ʸĹ */
#define MAXDEPTH 32      /* ǥ쥯ȥĥ꡼ο */

/*
 *  ¾
 */
#define LABELSIZ 11                          /* ܥ塼٥ʸ */
#define VOLUMELABEL "BSDFILER   "  /* serverΤܥ塼٥ */
#define BASNAMSIZ 8
#define FILNAMSIZ 13       /* 8 (basename) + 1 ('.') + 3 (ext) + 1 (EOS) */
#define ISDIR 0x02
#define ISREG 0x00
#define DOSPATHSEP '\\'
#define UNIXPATHSEP '/'
#define ENTDIR 0x10       /* GETDIRNET ǥǥ쥯ȥΤȤ */
#define ENTFIL 0x20       /* GETDIRNET ǥեΤȤ */
#define TIMEOUT 15        /* sec */
#define DATBLKSIZ 0x0800  /* եžΥǡ֥å */
#define BPS 9600          /* ǥեȤΥꥢ® */

/*
 *  ¤
 */
/* ǥ쥯ȥꥨȥ */
typedef struct {
    unsigned char type;
    long timestamp;
    long size;
    unsigned char name[FILNAMSIZ];
} lxdirent;


/* ॹ */
typedef struct {
    unsigned int sec: 5;
    unsigned int min: 6;
    unsigned int hour: 5;
    unsigned int day: 5;
    unsigned int mon: 4;
    unsigned int year: 7;
} dos_time_stamp;

/* ॹפ long ˥㥹 */
typedef union {
    dos_time_stamp dos;
    long val;		/* long  32ӥåȤȲꤹΤɤʤʤ */
} stamp_t;


/*
 *  ؿץȥ
 */
/* emul.c */
int emulserver(int fd);

/* file.c */
unsigned long tmstamp(char *name);
int filetype(char *name);
long diskfree();
char *unixpath(char *path);
char *dospath(char *path);
char **searchdir(char *wildcard,
                 char *entries[MAXDIRENT + 1],
		 char filnams[MAXDIRENT * FILNAMSIZ]);
lxdirent *direntry(char *name);
FILE *efopen(char *path, char *mode);
int movedir(char *path, char *new);
char *serverpath(char *curdir, char *path);

/* packet.c */
int recvpacket(int fd, unsigned char *buf);
void sendpacket(int fd, int len, unsigned char *buf);
int setbyte(unsigned char *buf, int ofs, unsigned char n);
unsigned short getshort(unsigned char *buf, int ofs);
int setshort(unsigned char *buf, int ofs, unsigned short n);
unsigned long getlong(unsigned char *buf, int ofs);
int setlong(unsigned char *buf, int ofs, unsigned long n);
int getmesg(unsigned char *buf, int ofs, char *msg);
int clrparm(char *buf, int pos, int len);
int setparm(char *buf, int pos, int len, char *parm);
int setmesg(char *buf, int pos, int len, char *msg);

/* crc.c */
void tblini();
unsigned short crc16c(unsigned short crc, unsigned char ch, int rev);

/* tty.c */
int opentty(char *devicename);
void ttyinit(int fd, int bps);
void ttyrestore(int fd);
int ttyputc(int fd, char ch);
int ttygetc(int fd);

/*
 *  ޤ
 */
